clc;clear;close all

%%%verification of single IIR Filter by comparing matlab and verilog
cd('/data/work/thfu/TailCorr/script_m');

a = 13740916;
b = -1047703;
y(1) = 0;

sel_double = 0;

switch sel_double
    case 0
        iir_in = int64(importdata("/home/thfu/work/TailCorr/v02/sim/in") -32768);
        iir_out = int64(importdata("/home/thfu/work/TailCorr/v02/sim/out") -32768);
    case 1
        iir_in = double(importdata("/home/thfu/work/TailCorr/v02/sim/in") -32768);
        iir_out = double(importdata("/home/thfu/work/TailCorr/v02/sim/out") -32768);
end

Script_out = MyIIR(a,b,iir_in,y(1),sel_double)';
y_revised = iir_in + Script_out;
tau = finddelay(y_revised,iir_out);

Script_outPhi = cat(1,zeros(1,tau)',Script_out(1:end-tau,1));

n = 1:length(iir_in);
diff = iir_out(n)-Script_outPhi(n);

diff_plot(iir_out, Script_outPhi)
tau
