clc;clear;close all

cd('/data/work/thfu/TailCorr/script_m');

sel_double = 1;

switch sel_double
    case 0
        iir_in = int64(importdata("/home/thfu/work/TailCorr/v02/sim/in") -32768);
        iir_out = int64(importdata("/home/thfu/work/TailCorr/v02/sim/out") -32768);
    case 1
        iir_in = double(importdata("/home/thfu/work/TailCorr/v02/sim/in") -32768);
        iir_out = double(importdata("/home/thfu/work/TailCorr/v02/sim/out") -32768);
end

alpha = [1757225200, 1045400392, 13740916];
beta = -[1042856 1046395 1047703];


Ystart = 0;

y_revised = TailCorr(alpha,beta,iir_in,Ystart,sel_double);

tau = finddelay(y_revised,iir_out);
y_revisedPhi = cat(1,zeros(1,tau)',y_revised(1:end-tau,1));

diff_plot(iir_out, y_revisedPhi,'verdi','matlab',[0 1e4])
