%%%2024-10-17,verify 8 intp by comparing matlab and verilog
clc;clear all;close all;

in = importdata("/home/thfu/work/TailCorr/sim/in_intp8.dat");
intp8_verilog = importdata("/home/thfu/work/TailCorr/sim/out_intp8.dat");

N = length(in);
time = 1:1:N;
time8 = 1:1/8:N+1-1/8;
intp8_matlab = floor(interp1(time,in,time8,'linear'))';

%figure
%plot(time,in);
%hold on
%plot(time8,intp8_verilog);
%xlim([4500 5500])

tau8 = finddelay(intp8_matlab(1.8e4:3e4),intp8_verilog(1.8e4:3e4));
intp8_matlab_revised = cat(1,zeros(1,tau8)',intp8_matlab(1:end-tau8,1));
figure('Units','normalized','Position',[0.000390625,0.517361111111111,0.49921875,0.422916666666667]);
diff_plot(intp8_verilog, intp8_matlab_revised,'verdi','matlab',[2e4 2.2e4]);
